/******************************************************************************
 * Licensed Materials - Property of IBM                                       *
 *                                                                            *
 * PID (5697-TKT)                                                             *
 *                                                                            *
 * (C) Copyright by IBM 2000. All Rights Reserved.                            *
 *****************************************************************************/
package com.BobCo.postit;

import com.tivoli.twg.libs.Command;
import com.tivoli.twg.libs.IntelByteBuffer;
import com.tivoli.twg.libs.LongValueSet;

/**
 * Command class for removing a reminder note association from a specific
 * set of mos that were displayed in this task bean's association view.
 */
public class BCRemovePostItNoteCmd extends Command
{
  /**
   * Constructor for remove post it note command
   * @param note_id - the unique id of the note to remove
   * @param oids - the list of one or more object ids to remove the note from
   */
  public BCRemovePostItNoteCmd( long note_id, LongValueSet oids )
  {
    super( BCPostItConstants.REMOVE_POST_IT_NOTE_CMD );
    SetDestinationAddress( BCPostItConstants.POST_IT_SERVER );

    int   iBBLength = 0;
    IntelByteBuffer iBB = null;

    /* Parm 0 = active console id and list of object ids                */
    // Talley length of buffer.
    iBBLength = IntelByteBuffer.SIZEOF_LONG64 +
                IntelByteBuffer.GetLongValueSetLength(oids);

    // Allocate the Intel byte buffer.
    iBB = new IntelByteBuffer( iBBLength );

    // Write parameters to buffer and attach to command.
    iBB.WriteLong64( note_id );
    iBB.WriteLongValueSet( oids );
    AddInputParm( iBB.GetBuffer() );
  }
}

