package com.BobCo.FileExplorerJVM;

import com.tivoli.twg.engine.InvalidObjectIDException;
import com.tivoli.twg.engine.TWGExtension;
import com.tivoli.twg.engine.TWGExtensionInitException;
import com.tivoli.twg.engine.TWGExtensionTermException;
import com.tivoli.twg.engine.TWGPersistentObjectSaveException;
import com.tivoli.twg.engine.TWGTask;
import com.tivoli.twg.engine.TWGTaskCreationException;
import com.tivoli.twg.engine.TWGDefaultTask;
import com.tivoli.twg.log.TWGRas;
import java.util.Properties;

/**
 * Extension class : defined by the BobCoFileExplorerJVM.TWGExt property file.
 */
public class BobCoFileExplorerJVMExtension extends TWGExtension
{
  /**
   * Default constructor : usually does nothing, but can access
   * properties loaded from our property file.
   */
  public BobCoFileExplorerJVMExtension()
  {
    super();
    System.out.println("BobCoFileExplorerJVMExtension() constructor"
                      +" to log\\com.tivoli.twg.engine.TWGServerMain.output");
    try
    {
      System.out.println("BobCoFileExplorerJVMExtension() consructor ObjectID="+ ObjectID() );
    }
    catch (InvalidObjectIDException ioidx)
    {
      System.out.println("<invalid>");
    }
    Properties p = getPropertySet();
    p.list(System.out); /* Dump properties                          */
    System.out.println("Leaving BobCoFileExplorerJVMExtension() constructor");
  }
  /**
   * First initialization method, intended to allow extensions to register
   * classes.
   *
   * @exception TWGExtensionInitException if a fatal error occurs during
   * the initialization method
   */
  public void InitClassRegistration() throws
  TWGExtensionInitException
  {
    System.out.println("BobCoFileExplorerJVMExtension.InitClassRegistration()"
                      +" to log\\com.tivoli.twg.engine.TWGServerMain.output");

    String c = "";
    try
    {    
        c = "com.BobCo.FileExplorerJVM.BobCoFileExplorerJVMServer";
        RegisterClass( c );
    }
    catch (ClassNotFoundException cnfx)
    {
        System.out.println("Class '"+ c +"' not found: throwing ClassNotFoundException");
        throw new TWGExtensionInitException("Class '" + c + "' not found: " + cnfx);
    }
    System.out.println("Leaving BobCoFileExplorerJVMExtension.InitClassRegistration()");
  }

  /**
   * Second initialization method, intended to allow extension to create
   * default instances of classes registered during InitClassRegistration().
   *
   * @exception TWGExtensionInitException if a fatal error occurs during
   * the initialization method
   */
  public void InitClassInstances() throws TWGExtensionInitException
  {
    System.out.println("BobCoFileExplorerJVMExtension.InitClassInstances()"
                      +" to log\\com.tivoli.twg.engine.TWGServerMain.output");
    boolean err = false;

    // Instantiate FileExplorerJVM server in a seperate JVM according to the properties file
    if (!TWGTask.isTaskID("BobCo|FileExplorerJVM"))
    {
      try
      {
        TWGDefaultTask bobCoTask = new TWGDefaultTask("com/BobCo/FileExplorerJVM/BobCoFileExplorerJVMTask.properties");
      }
      catch (TWGTaskCreationException e)
      {
        System.out.println("Task creation exception!!!");
        e.printStackTrace();
        err = true;
      }
    }

    if (err)
    {
      throw new TWGExtensionInitException("error creating TWGDefaultTask(s)");
    }
    System.out.println("Leaving BobCoFileExplorerJVMExtension.InitClassInstances()");
  }

  /**
   * Final initialization method, intended to allow an extension to do any
   * actions which may have required the other extensions to have completed
   * the previous passes of initialization.
   *
   * @exception TWGExtensionInitException if a fatal error occurs during
   * the initialization method
   */
  public void InitCompletion() throws TWGExtensionInitException
  {
    System.out.println("BobCoFileExplorerJVMExtension.InitCompletion()");
    boolean err = false;
    /*- Do task association stuff here */
    if (err)
    {
      throw new TWGExtensionInitException();
    }
  }
  /**
   * First termination method, intended to allow an extension to begin
   * the process of termination.  The only termination processing which
   * should occur here is that which needs to be done before other
   * extensions have executed TermCompletion() pass.
   *
   * @exception TWGExtensionTermException if an error occurs during the
   * termination method
   */
  public void TermBegin() throws TWGExtensionTermException
  {
    System.out.println("BobCoFileExplorerJVMExtension.TermBegin()");
    boolean err = false;
    /*- Do initial termination processing here */
    if (err)
    {
      throw new TWGExtensionTermException();
    }
  }
  /**
   * Final termination method, intended to allow an extension to terminate
   * any processing which may still be active.
   *
   * @exception TWGExtensionTermException if an error occurs during the
   * termination method
   */
  public void TermComplete() throws TWGExtensionTermException
  {
    System.out.println("BobCoFileExplorerJVMExtension.TermComplete()");
    boolean err = false;
    /*- Do final termination processing here */
    if (err)
    {
      throw new TWGExtensionTermException();
    }
  }
}
