package com.ibm.sysmgt.sdk.CmdTask;

/**
 * This interface defines the constants that need to be shared among
 * the CmdTask classes.
 */
public interface CmdTaskConstants {
    /** Name of CmdTask server's service node */
    public static final String CMDSERVERNAME = "CmdTaskServer";

    /** Command code issued to client to request list of local fixed drives */
    public static final int    GetCommandStringCmdCode       = 0x00000001;

    public static final int    RETURN_OKAY                      = 0;
    public static final int    RETURN_UNRECOGNIZED_COMMAND_CODE = 1;
    public static final int    RETURN_FIND_FAILED               = 2;
    public static final int    RETURN_UNRECOGNIZED_ACT_ID       = 3;

    public static final int    OS_WINDOWS 			= 1;
    public static final int    OS_LINUX				= 2;
    public static final int    OS_UNIX				= 2;

    /** Read only file attribute */
    public static final int    READONLY  = 0x00000001; // read only attribute
    /** "Hidden" file attribute */
    public static final int    HIDDEN    = 0x00000002; // hidden attribute
    /** "System" file attribute */
    public static final int    SYSTEM    = 0x00000004; // system attribute
    /** Directory attribute */
    public static final int    DIRECTORY = 0x00000010; // directory attribute
    /** Archive file attribute */
    public static final int    ARCHIVE   = 0x00000020; // archive attribute
}
