package com.ibm.sysmgt.sdk.CmdTask;

import java.io.ObjectStreamException;       //buildsys
import java.io.NotSerializableException;
import java.lang.ClassNotFoundException;    //buildsys
import java.text.MessageFormat;             //buildsys
import java.util.Locale;
import java.util.TimeZone;
import java.util.Vector;
import java.util.Date;
import java.util.Hashtable;
import java.util.Enumeration;
import com.tivoli.twg.engine.GlobalUniqueID;
import com.tivoli.twg.engine.TWGFilterNotifyCmd;
import com.tivoli.twg.libs.*;
import com.tivoli.twg.log.*;
import com.tivoli.twg.util.*;
import java.io.ObjectStreamException;
import java.io.NotSerializableException;
import com.tivoli.twg.log.TWGRas;


/**
 * TWGEventManagerServiceNode.
 */

public class CmdTaskServiceNode extends ServiceNode
{
   /**
    * Command to be passed to TWGRemoteTaskManager.addActivationListener().
    * Also specified in TWGEventServerTask.properties ServiceNode.Forward.
    */
   static final int TASK_COMMAND = 12345;

// Not used
//   /** Command to receive base events. */
//   public static final int SEND_BASE_EVENT_CMD = TWGEventConstants.EVENTMGR_SEND_BASE_EVENT_CMD;

   /** Command to get commandstring. */
   public static final int CMDTASK_GET_COMMANDSTRING = GetCmdStringCommand.CMDTASK_GET_COMMANDSTRING;

   /** Command to run an action using an internally generated event. */
   public static final int EVENTMGR_TEST_ACTION =  0x0A0A0207;


   /** Command Return Codes. */
   public static final int RC_SUCCESS            = 0x00000000;
   public static final int RC_DUPLICATE_NAME     = 0x00000101;
   public static final int RC_INVALID_INPUT_PARM = 0x00000102;
   public static final int RC_FILTER_REFERENCED  = 0x00000103;
   public static final int RC_ACTION_REFERENCED  = 0x00000104;
   public static final int RC_PLAN_REFERENCED    = 0x00000105;
   public static final int RC_DUPLICATE_OBJECT   = 0x00000106;
   public static final int RC_REQUEST_FAILED     = 0x00000107;
   public static final int RC_NOT_AVAILABLE      = 0x00000108;
   public static final int RC_FILE_EXISTS        = 0x00000109;
   public static final int RC_NO_FILE_EXISTS     = 0x0000010A;

   /** Internal Return Codes. */
   public static final int RC_INVALID_KEY        = 0x00001001;
   public static final int RC_INVALID_CMD_INPUT  = 0x00001002;
   public static final int RC_INVALID_CMD_CODE   = 0x00001003;
   public static final int RC_EXCEPTION          = 0x00001004;

   /** Constants. */
   public static final int DO_IF_NOT_REFERENCED  = 0x00000000;
   public static final int DO_IF_NO_CONFLICT     = 0x00000000;
   public static final int DO_REMOVE_ASSOCIATION = 0x00000000;
   public static final int DO_CONFIRM            = 0x00000001;
   public static final int DO_KEEP_ASSOCIATION   = 0x00000002;
   public static final int WRITE_TO_SERVER       = 0x00000001;

   /* Conflict flags used for import plans. */
   static final short IMPORT_FLAGS_OBJECT_NOT_VALID  = 0x0001;
   static final short IMPORT_FLAGS_DIFFERENT_VERSION = 0x0002;
   static final short IMPORT_FLAGS_DUPLICATE_NAME    = 0x0004;
   static final short IMPORT_FLAGS_READ_ONLY_EXISTS  = 0x0008;
   static final short IMPORT_FLAGS_DUPLICATE_EXISTS  = 0x0010;
   static final short IMPORT_FLAGS_MODIFIED_EXISTS   = 0x0020;

   private static final String RAS_HEADER = "CmdTaskServiceNode: ";

   /* private variables */
   private boolean          terminating = false;

   private static CmdTaskServiceNode serviceNode = null;                
   /** Constructor. */
   public CmdTaskServiceNode(String name) throws ServiceNodeException,
                                                         ServiceNodeClosedException,
                                                         BadServiceNodeImplException
   {
      super(name);
      serviceNode              = this;
   }

   public void CommandComplete()
   {
      TWGRas.debug(TWGRas.EX0,"CmdTask.CmdTaskServiceNode.CommandComplete Called");
   }

   public boolean CommandReceived(Command cmd)
   {
      if (cmd.CommandCode() == CMDTASK_GET_COMMANDSTRING) {
	  getCommandString(cmd);
      }
      return true;
   }

 
   private void getCommandString(Command cmd){
	TWGRas.debug(TWGRas.EX0,"CmdTask.CmdTaskServiceNode.getCommandString Called");
	String commandString = "";
	boolean shellRequired = false;
	String cwd = null;
	String windowsAgentCwd = null;
	String unixAgentCwd = null;
	GetCmdStringCommand gcmd= new GetCmdStringCommand(cmd);
	if( cmd.NumInputParms() > 1 ){
	    String taskID = null;
	    int platform = -1;
	    taskID = gcmd.getTaskID();
	    platform = gcmd.getPlatform();
	    TWGRas.debug(TWGRas.EX0,"CmdTaskServiceNode.getCommandString for " + taskID );
	    CmdTaskData cmdTaskData = CmdTaskExtension.getCmdTaskData(taskID);
	    switch (platform) {
	    case GetCmdStringCommand.Windows :
		commandString = cmdTaskData.getWindowsCommandString();
		cwd = cmdTaskData.getWindowsCwd();
		break;
	    case GetCmdStringCommand.Unix :
		commandString = cmdTaskData.getUnixCommandString();
		cwd = cmdTaskData.getUnixCwd();
		break;
	    default: 
	       commandString = new String("");
	       cwd = new String("");
	       //cmd.SetReturnCode(RC_INVALID_CMD_INPUT);
	    }
	    shellRequired = cmdTaskData.getShellRequired();
	    

	    //gcmd.	// Only superclass Command can be received at ServiceNode, therefore must use static method
	    GetCmdStringCommand.setCommandString(cmd, 
						 commandString != null ? commandString : "", 
						 shellRequired, 
						 cwd != null ? cwd : "");

	    String urlType = cmdTaskData.getUrlType();
	    String urlPort = cmdTaskData.getUrlPort();
            String urlFile = cmdTaskData.getUrlFile();
	    GetCmdStringCommand.setUrlString(cmd, 
					     urlType != null ? urlType : "", 
					     urlPort != null ? urlPort : "", 
					     urlFile != null ? urlFile : "");

	    
            String commandStringWindows = cmdTaskData.getWindowsAgentCommandString();
            String commandStringUnix = cmdTaskData.getUnixAgentCommandString();
	    int agentTimeout = cmdTaskData.getAgentTimeout();
            windowsAgentCwd = cmdTaskData.getWindowsAgentCwd();
	    unixAgentCwd = cmdTaskData.getUnixAgentCwd();
	    GetCmdStringCommand.setAgentCommandStrings(cmd, 
						 commandStringWindows != null ? commandStringWindows : "", 
						 commandStringUnix != null ? commandStringUnix : "",
						 agentTimeout, 
						 windowsAgentCwd != null ? windowsAgentCwd : "",
						 unixAgentCwd != null ? unixAgentCwd : "");
       } else 
	   cmd.SetReturnCode(RC_INVALID_CMD_INPUT);
       // cmd = (Command) gcmd;
   }
} // end class CmdTaskServiceNode
