/////////////////////////////////////////////////////////
// Module		HelpDialog.java
// Version		3.10
// Language		Java
// Author		Scott Riley
// History
// 06/09/00    Release 3.10
// 10/26/99    Initial release
//
// Copyright (C) 1999-2000 Tivoli Systems, and IBM Company  
//
////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class HelpDialog extends Dialog
{
   //  Define an inner class to listen for only one window event
   class MyAdapter extends WindowAdapter implements WindowListener {
      public void WindowClosing (WindowEvent evt) {
         dispose();
      }
   }
	// Constructor
	HelpDialog(Frame f)
	{
		super(f, true);
		
		// Don't need that precise a layout.  So BorderLayout
		setLayout(new BorderLayout());

		String helpTextString = new String("\t\tDirector SDKFind Help");

		// Create the text area and add the help text
		TextArea helpTextArea = new TextArea();								
		helpTextArea.setText(helpTextString);
		helpTextArea.append("\n\n\n");

		helpTextArea.append("Use the Find Text function to locate a string anywhere in the SDK documents.\n\n");
		helpTextArea.append("Enter words in the text area beside 'Search For', e.g. 'Software Distribution'.\n\n");

		helpTextArea.append("Choose a search option:\n");
		helpTextArea.append("\tall the words - search for pages with the words 'Software' AND 'Distribution'\n");
		helpTextArea.append("\tany of the words - search for pages with the words 'Software' OR 'Distribution'\n");
		helpTextArea.append("\texact phrase - search for pages with the string 'Software Distribution'\n\n");

		helpTextArea.append("By default, searches are not sensitive to case.  Searches for 'Software Distribution'\n");
		helpTextArea.append("would match pages with 'Software Distribution', 'software distribution' and other variations.\n");
		helpTextArea.append("If you want to match pages only with 'Software Distribution', check the box\n");
		helpTextArea.append("labeled 'exact case'.\n\n");

		helpTextArea.append("Click on the 'Search' button to find the text.\n");
		helpTextArea.append("Titles of pages matching the query will be listed in the box labeled 'Search Results'.\n\n");
	
		helpTextArea.append("Click on a line in the 'Search Results' box to view the page matching the query.\n");
		helpTextArea.append("This will display the page on the right panel of the SDK document.\n");
	
		helpTextArea.setEditable(false);
		add("Center", helpTextArea);

/*		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
		buttonPanel.add(new Button("OK"));
		buttonPanel.validate();
		add("South", buttonPanel);        */
		validate();
		setSize(500,380);
      WindowListener adapter = new MyAdapter();
      addWindowListener(adapter);
		show();
	}

	// Event Handler
	// When the user has read enough, dispose the dialog.
	public void processEvent(AWTEvent evt)  {
      if(evt.getID() == WindowEvent.WINDOW_CLOSING){
			dispose();
      }
   }

}		
