/*
 * Created on Nov 11, 2003
 *
 * 
 */
package com.ibm.sysmgt.sdk.remote.test;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;

import junit.framework.Assert;
import junit.framework.TestCase;

import com.ibm.sysmgt.sdk.remote.DirectorEvent;
import com.ibm.sysmgt.sdk.remote.DirectorEventLog;
import com.ibm.sysmgt.sdk.remote.DirectorRemoteSdk;
import com.ibm.sysmgt.sdk.remote.DirectorServer;
import com.ibm.sysmgt.sdk.remote.Log;
import com.ibm.sysmgt.sdk.remote.LoginSession;
import com.ibm.sysmgt.sdk.remote.ManagedGroup;
import com.ibm.sysmgt.sdk.remote.ManagedSystem;
import com.ibm.sysmgt.sdk.remote.Task;
import com.ibm.sysmgt.sdk.remote.UnknownManagerException;
import com.tivoli.twg.libs.DataValue;
import com.tivoli.twg.libs.TWGDate;
import com.tivoli.twg.libs.TWGEnvironment;

/**
 * @author Dave Wormald
 *
 * 
 */

public class SetupToUseDirectorServer extends RemoteSdkTestCase {

	protected static DirectorServer mgr = null;
	protected static LoginSession s;

	protected final void setUp() throws Exception {
		super.setUp();
		println(
			"============== setUp(" + this.getName() + ") =============");
		System.setProperty(
			TWGEnvironment.PROP_DIR_DATA,
			"c:"
				+ File.separator
				+ "Program Files"
				+ File.separator
				+ "IBM"
				+ File.separator
				+ "director"
				+ File.separator
				+ "data");
		try {
			mgr = DirectorRemoteSdk.getManager("localhost");
		} catch (UnknownManagerException ume) {
			System.out.println("UnknownManagerException=" + ume);
			ume.printStackTrace();
		}

		try {
			s =
				mgr.createLoginSession(
					"dirconsole",
					"asdf",
					Locale.getDefault());
			Assert.assertTrue("Session is bad", (s != null));
			Assert.assertTrue("Session is bad", s.isActive());
			
			Assert.assertTrue(
				"manager is not active",
				(mgr.isManagerActive(s)));

		} catch (Exception e) {
			fail();
		}

	}

	public void tearDown() {
		println(
	"============== tearDown(" + this.getName() + ") =============");
		s.endSession();
	}

	/**
	 * 
	 */
	public SetupToUseDirectorServer() {
		super();

	}

	/**
	 * @param arg0
	 */
	public SetupToUseDirectorServer(String arg0) {
		super(arg0);
	}

}
