
package com.BobCo.rmon;

import com.tivoli.twg.engine.*;
import com.tivoli.twg.log.TWGRas;
import com.tivoli.twg.libs.IntelByteBuffer;
import com.tivoli.twg.alertmgr.TWGEventServer;
import java.util.*;
import java.net.*;
import com.tivoli.twg.snmp.*;
import com.tivoli.twg.libs.*;


public class TWGRMONTest implements java.util.Observer{
TWGMofInstanceOf Callback = null;
TWGSNMPDevice   Device   = null;
static Hashtable List    = new Hashtable();
private InetAddress MyAddress = null;
static SNMP Stack = null;

   public TWGRMONTest(TWGMofInstanceOf Factory,TWGSNMPDevice mo){
      this.Callback = Factory;
      this.Device   = mo;
      List.put(mo.GetAddress(),this);   // add this one to the list here so we don't loose the ref
      try{
         if(Stack == null) Stack = TWGSNMPDevice.GetSNMPStack();
         SNMPEntity Dest = new SNMPEntity(Stack,mo.GetAddress());  // target address
         SNMPContext Con = new SNMPContext(Stack,mo.GetContext()); // get the context here
         MyAddress = InetAddress.getLocalHost();
         SNMPEntity Source = new SNMPEntity(Stack,MyAddress.getHostAddress());
         SNMPPDU Sender = new SNMPPDU(Stack,SNMPPDU.SNMP_PDU_GETNEXT,this);
//         Sender.AddVblItem(0,"1.3.6.1.2.1.1.0");  // get the first element in the attable
//         Sender.AddVblItem(0,"1.3.6.1.2.1.2.0");  // get the first element in the attable
         Sender.AddVblItem(0,"1.3.6.1.2.1.16.0");  // get the first element in the attable
         if(Stack.SubmitPDU(Source,Dest,Con,Sender) != 1)
            Callback.callback(TWGManagedObjectFactory.INSTANCE_OF_NO_RESPONSE);
      }
      catch(UnknownHostException err2){
         Callback.callback(TWGManagedObjectFactory.INSTANCE_OF_NO_RESPONSE);
      }
   }


   /**
     *
     * This method is used as the observer for all Get/GetResponse operations performed
     * to accomplish SNMP Discovery.  It is called by the Request SNMPPDU instance when it
     * completes.  This could be due to a timeout, as well as a response.
     *
     * @param   The Observed object - SNMPPDU request.
     *
     */

   public void update(Observable o,Object arg){
      int RC = TWGManagedObjectFactory.INSTANCE_OF_NO_RESPONSE;  // default to the don't know case
      SNMPPDU Base = (SNMPPDU)o;   // type it so we can use it here

      List.remove(Base.GetResponseDest().GetAddress());  // take it out of the list
      if(Base.IsTimedOut() == false){   // make sure this is not a timeout first
         SNMPPDU Rcv = Base.GetResponsePDU();
         if(Rcv != null){
            if(Rcv.GetError() == 0){   // if the error code for the PDU was good only
               // now check the returned information here for the RMON OIDs
               int Counter = 0;
               int Count = Rcv.GetVblCount();   // get the number of elements we got back
               if(Count == 1){ // walk through the list, better be only one
                     String Name = Rcv.GetVblItemName(1);
                     if(Name.startsWith("1.3.6.1.2.1.16") == true){
                        if(Rcv.GetVblItemType(1) != SNMPPDU.SNMP_SYNTAX_NULL) Counter++;
                     }
               }
               if(Counter == 1 ) RC = TWGManagedObjectFactory.INSTANCE_OF_YES;
               else RC = TWGManagedObjectFactory.INSTANCE_OF_NO;
            }
            else RC = TWGManagedObjectFactory.INSTANCE_OF_NO;
            Rcv.Done();
            Rcv = null;
         }
      }
      Base.Done();
      Base = null;
      Callback.callback((byte)RC);  // call back into Mike C. and let him know what's up
   }


}

