/*
 * Created on Jan 15, 2004
 *
 * 
 */
package com.ibm.sysmgt.sdk.remote.test;

import java.util.Locale;
import java.util.Vector;

import com.ibm.sysmgt.sdk.remote.server.RemoteApiException;
import com.ibm.sysmgt.sdk.remote.server.RemoteApiService;
import com.ibm.sysmgt.sdk.remote.server.RemoteSdkApi;
import com.ibm.sysmgt.sdk.remote.server.ServerRemoteApi;
import com.tivoli.twg.log.TWGRas;

import junit.framework.TestCase;

/**
 * @author Dave Wormald
 *
 * 
 */
public class TestReflection extends TestCase {

	class ClassBase {
		public int x;
		public ClassBase() {
			x = 1;
		}
		public int getLevel() {
			return 1;
		}
	}

	class ClassSubClass1 extends ClassBase {
		public ClassSubClass1() {
		}
		public int getLevel() {
			return 2;
		}

	}

	class ClassSubClass2 extends ClassSubClass1 {
		public ClassSubClass2() {
		}
		public int getLevel() {
			return 2;
		}

	}

	class ReflectionTestRemoteApi extends RemoteSdkApi {

		/**
		 * 
		 */
		public ReflectionTestRemoteApi() {
			super();

		}

		/* (non-Javadoc)
		 * @see com.ibm.sysmgt.sdk.remote.server.RemoteSdkApi#getName()
		 */
		public String getName() {
			return "Test";
		}

		public String[] getApiDocumentation() {
			return null;
		}

		public Object MyTestMethod(Locale locale, ClassBase c) {

			return  "asdf";

		}

	}

	public void testReflection() {

		TWGRas.initialize();

		RemoteApiService.initialize();
		RemoteApiService.registerApi(new ReflectionTestRemoteApi());

		Vector parms = new Vector();
		ClassBase parm = new ClassSubClass1();
		parms.add(parm);

		Object result = null;

		try {
			result =
				RemoteApiService.execute(
					"Test",
					"MyTestMethod",
					parms,
					Locale.getDefault());
		} catch (RemoteApiException e) {
			e.printStackTrace();
		}

		if (result != null) {

		}

	}

	/**
	 * 
	 */
	public TestReflection() {
		super();
	}

	/**
	 * @param arg0
	 */
	public TestReflection(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
	}
}
