/*
 * Created on Dec 4, 2003
 *
 * 
 */
package com.ibm.sysmgt.sdk.remote.test;

import java.util.List;

import com.ibm.sysmgt.sdk.remote.*;
import com.tivoli.twg.libs.DataValue;

/**
 * @author Dave Wormald
 *
 * 
 */
public class TestThresholds extends SetupToUseDirectorServer {

	public void testGetAllThresholds() {

		if (s == null)
			fail();

		try {
			List systemlist = ManagedSystem.getAllSystems(s);
			ManagedSystem m = (ManagedSystem) systemlist.get(0);

			List thresholdList = Threshold.getAllThresholds(s);
			assertNotNull(thresholdList);
			assertTrue(thresholdList.size() > 0);

			for (int i = 0; i < thresholdList.size(); i++) {
				Threshold thresh = (Threshold) thresholdList.get(i);

				System.out.println("Threshold=" + thresh);

			}

		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	public void testEnableThreshold() {
		if (s == null)
			fail();
		try {
			List systemlist = ManagedSystem.getAllSystems(s);
			ManagedSystem m = (ManagedSystem) systemlist.get(0);

			List thresholdList = Threshold.getAllThresholds(s);
			assertNotNull(thresholdList);
			assertTrue(thresholdList.size() > 0);
			Threshold thresh = (Threshold) thresholdList.get(0);
			boolean retval = thresh.setEnabled(s, true);
			if (!retval) {
				fail("Not Enabled");
			}
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	public void testDisableThreshold() {
		if (s == null)
			fail();
		try {
			List systemlist = ManagedSystem.getAllSystems(s);
			ManagedSystem m = (ManagedSystem) systemlist.get(0);

			List thresholdList = Threshold.getAllThresholds(s);
			assertNotNull(thresholdList);
			assertTrue(thresholdList.size() > 0);
			Threshold thresh = (Threshold) thresholdList.get(0);
			boolean retval = thresh.setEnabled(s, false);
			if (retval) {
				fail("Disable failed");
			}
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}

	public void testGetCurrentValue() {
		if (s == null)
			fail();
		try {
			List systemlist = ManagedSystem.getAllSystems(s);
			ManagedSystem m = (ManagedSystem) systemlist.get(0);

			List thresholdList = Threshold.getAllThresholds(s);
			assertNotNull(thresholdList);
			assertTrue(thresholdList.size() > 0);
			Threshold thresh = (Threshold) thresholdList.get(0);
			DataValue retval = thresh.getCurrentValueForSystem(s,m);
			assertNotNull(retval);
			
			println("Current Threshold Value = "+retval);
			
		} catch (Exception e) {
			fail(e.getMessage());
		}
	}



	/**
	 * 
	 */
	public TestThresholds() {
		super();
	}

	/**
	 * @param arg0
	 */
	public TestThresholds(String arg0) {
		super(arg0);
	}

}
