// Licensed Materials - Property of IBM
//
// OCO Source Materials
// 
// 09N6996
//
// (C) Copyright IBM Corp. 1999, 2001 All Rights Reserved
//
// The source code for this program is not published or other-
// wise divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
 
#include <iostream.h>
#include <stdio.h>
#include <windows.h>
#include "nfwincom.hpp"
#include "wnfipc.hpp"
#include "cmd.hpp"
#include "svcnode.hpp"
#include "msglogr.hpp"

FILE *stream;

// Command processor for msglogr
BOOL MsgSvcNode::CommandReceived(Command &cmd)
{
   // Vars for the input parameters
   unsigned short severity;
   char * message;

   cout << "Msg received..." << endl;
   switch (cmd.CommandCode()) {

   // Command code for synchronously sent commands.
   case LOG_MSG:
      // Retrieve the input parameters
      severity = *(unsigned short *) cmd.InputParm(0);
      message = (char *) cmd.InputParm(1);
      // Log the message
      stream = fopen("MESSAGE.LOG", "a+"); // open the log file for append
      fprintf(stream, "Severity %d message from %s: %s\n", severity, 
                                                           cmd.DestinationAddress(), 
                                                           message);
      fclose(stream); // close the log file
      cmd.SetReturnCode(0);
      break;

   // Command code for asynchronously sent commands.
   case LOG_MSG_ASYNCH:
      // Retrieve the input parameters
      severity = *(unsigned short *) cmd.InputParm(0);
      message = (char *) cmd.InputParm(1);
      // Log the message
      stream = fopen("MESSAGE.LOG", "a+"); // open the log file for append
      fprintf(stream, "Severity %d asynchronous message from %s: %s\n", severity, 
                                                                        cmd.DestinationAddress(),
                                                                        message);
      fclose(stream); // close the log file
      cmd.SetReturnCode(0);
      break;

   // All other commands.
   default:
      cmd.SetReturnCode(1);
      break;
   }
   return TRUE;
}

void __cdecl main()
{
   cout << "Starting..." << endl;
   // Create our service node
   MsgSvcNode *pMsgSvcNode = new MsgSvcNode();
   if (!pMsgSvcNode->Create()) {
      cout << "Agent:  Service node not created." << endl;
      return;
   }
   cout << "Ready..." << endl;
   // Start processing commands
   pMsgSvcNode->ProcessCommands();
   return;
}
